#!/usr/bin/python
# -*- coding: utf-8 -*-
import cgi
import Cookie
import sys
import json
import ldap

data = json.load(sys.stdin)

username = data["username"]
password = data["password"]

print "Content-type: text/html\n"
response = {"success":"false","fail":"false","code":0,"message":"","user":{"username":""}};

def check_credentials(username, password):
    SERVER_NAME = 'hostname'
    DOMAIN_NAME = 'foo.bar'
    
    LDAP_SERVER = 'ldap://%s.%s' % (SERVER_NAME,DOMAIN_NAME)
    LDAP_USERNAME = '%s@%s' % (username,DOMAIN_NAME)
    LDAP_PASSWORD = password

    try:
        ldap_client = ldap.initialize(LDAP_SERVER)
        ldap_client.set_option(ldap.OPT_REFERRALS,0)
        ldap_client.simple_bind_s(LDAP_USERNAME, LDAP_PASSWORD)
    except ldap.INVALID_CREDENTIALS:
        ldap_client.unbind()
        response["fail"] = "true"
        response["code"] = 3
        response["message"] = "Wrong username or password"
        print json.dumps(response)
    except ldap.SERVER_DOWN:
        ldap_client.unbind()
        response["fail"] = "true"
        response["code"] = 4
        response["message"] = "Server unavailable"
        print json.dump(response)
    ldap_client.unbind()
    response["success"] = "true"
    response["code"] = 2
    response["message"] = "Successful authentication"
    response["user"]["username"] = username
    print json.dumps(response)

check_credentials(username,password)
